/*
 * Trevor's quick hack to run a shell on port 23.
 *
 * Trevor Man <tman@laser.com> 09/02/02
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <arpa/telnet.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include <pthread.h>

// Prototypes
void main_program(void);		// Main part of daemon
void handle_connection(int socknum);	// Handle a connection

const int SOCKET_TCP_PORT = 23;	// What TCP port to listen to
const int SOCKET_MAX_BACKLOG = 5;

///////////////////////////////////////////////////////////////////////////
// Main
///////////////////////////////////////////////////////////////////////////
int main(int argc, char *argv[])
{
  fprintf(stderr, "Trevor's Empeg/RioCar Telnetd v1.0 - Copyright 2002, Trevor Man <tman@laser.com>\n");

  if (daemon(0, 0)) {
    perror("daemon");
    exit(1);
  }

  main_program();

  return 0;
}

///////////////////////////////////////////////////////////////////////////
// Main program
///////////////////////////////////////////////////////////////////////////
void main_program(void)
{
  pthread_t child; // Used to store pthread ID for child
  struct sockaddr_in addr; // Socket options
  int main_sock; // Socket that listens to main port
  unsigned int addrlen; // Size of sockadd_in structure
  int flag; // Flag for setsockopt
  int child_sock; // Socket created for each individual connection

  main_sock = socket(PF_INET, SOCK_STREAM, 0); // Create a TCP socket

  // Allow socket to be reused
  flag = 1; // Have to pass a variable to setsockopt
  if (setsockopt(main_sock, SOL_SOCKET, SO_REUSEADDR, &flag, sizeof(flag)) < 0) {
    exit(1); // Exit with an error for the moment
  }

  // Set options for bind
  addr.sin_family = AF_INET; // Set address family
  addr.sin_port = htons(SOCKET_TCP_PORT); // Set TCP port number
  addr.sin_addr.s_addr = INADDR_ANY; // Allow any source address
  addrlen = sizeof(addr);

  // Bind socket to TCP port
  if (bind(main_sock, (struct sockaddr *)&addr, addrlen) < 0) {
    exit(1); // Exit with an error for the moment
  }

  // Listen on socket
  if (listen(main_sock, SOCKET_MAX_BACKLOG < 0)) {
    exit(1); // Exit with an error for the moment
  }

  // Loop forever accepting new connections
  while (1) {
    // Accept new connections on main port
    child_sock = accept(main_sock, (struct sockaddr *) &addr, &addrlen);

    if (child_sock >= 0) { // Connection was successful
      // Spawn a new thread to handle the connection
      pthread_create(&child, NULL, (void *((*)(void *)))handle_connection, (void *)child_sock);
    } else { // Something went wrong?
      exit(1);
    }
  }
}

///////////////////////////////////////////////////////////////////////////
// Thread to handle a connection
///////////////////////////////////////////////////////////////////////////
void handle_connection(int sock_num)
{
  close(0);
  close(1);
  close(2);
  dup(sock_num);
  dup(sock_num);
  dup(sock_num);

  system("/bin/bash --login -i");

  close(0);
  close(1);
  close(2);
  close(sock_num);
  open("/dev/null", O_RDWR); 
  dup(0);
  dup(0);
}
